package com.guams.review.model;

import com.guams.review.model.dao.Author;
import org.springframework.data.jdbc.repository.query.Modifying;
import org.springframework.data.jdbc.repository.query.Query;
import org.springframework.data.repository.CrudRepository;
import org.springframework.stereotype.Repository;

import java.util.List;
import java.util.Optional;
import java.util.UUID;

@Repository
public interface AuthorRepository extends CrudRepository<Author, UUID> {

    @Modifying
    @Query("insert into publication (author_fk, post_fk) values (:authorId, :postId)")
    void insertPublication(UUID authorId, Long postId);

    @Modifying
    @Query("delete from publication where author_fk=:authorId and post_fk=:postId")
    void deletePublication(UUID authorId, Long postId);

    List<Author> findAll();

    Optional<Author> findByName(String name);
}
